part of viltage;

class ImgNode extends Node {
  String backgroundColor = null;
  CanvasImageSource _img;
  CanvasElement image;
  VilTAGE viltage;

  ImgNode(int x, int y, this._img, this.viltage, {double offX, double offY, String color}) {
    this.x = x;
    this.y = y;
    
    image = new CanvasElement(width:viltage.offX, height:viltage.offY);
    if(color == null) image.context2D.fillStyle = viltage.backgroundColor;
    else image.context2D.fillStyle = color;
    
    image.context2D.clearRect(0, 0, viltage.offX, viltage.offY);
    
    if(offX != null && offY != null) {
      image.context2D.drawImage(_img, offX, offY);
    } else {
      image.context2D.drawImageScaled(_img, 0, 0, viltage.offX, viltage.offY);
    }
  }
  
  /* creates identical ImgNode */
  ImgNode copy() {
    ImgNode newCn = new ImgNode(x, y, _img, viltage)..backgroundColor = backgroundColor;
    return newCn;
  }
  
  CanvasImageSource getSource() => _img;
}