part of viltage;

class VilTAGESound {
  static List<VilTAGESound> sounds = new List<VilTAGESound>();

  AudioElement _audio;
  String source;
  StreamController endedController = new StreamController();
  Stream onEnded;
  bool looping;
  
  VilTAGESound(this.source, {bool loop}) {
    _audio = new AudioElement();
    document.body.nodes.add(_audio);
    _audio.src = source;
    _audio.play();
    looping =loop==null?false:loop;
    sounds.add(this);

    onEnded = endedController.stream;
    _audio.onEnded.listen(end);
    _audio.setAttribute("type", "audio/ogg");
  }

  play() {
    _audio.play();
  }
  
  double getVolume() => _audio.volume;

  stop() {
    _audio.pause();
  }

  setVolume(double volume) {
    _audio.volume = volume;
  }
  
  end(Event e) {
    endedController.add(e);
    if(!looping) {
      _audio.pause();
      document.body.nodes.remove(_audio);
      sounds.remove(this);
    } else {
      double volume = _audio.volume;
      document.body.nodes.remove(_audio);
      
      _audio = new AudioElement();
      document.body.nodes.add(_audio);
      _audio.src = source;
      _audio.play();
      _audio.volume = volume;
      onEnded = endedController.stream;
      _audio.onEnded.listen(end);
      _audio.setAttribute("type", "audio/ogg");
    }
  }
}
