part of viltage;

class Input {
  static List<bool> _keys = new List<bool>();
  static List<bool> _lastKeys = new List<bool>();
  static List<bool> _banKeys = new List<bool>();
  
  static init() {
    for(int i = 0; i < 256; i++) {
      _keys.add(false);
      _lastKeys.add(false);
      _banKeys.add(false);
    }
    
    window.onKeyDown.listen((KeyboardEvent e) {
        _keys[e.keyCode]=true;
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys[e.keyCode]=false;
    });
  }

  static bool isHeld(int keyCode) => _keys[keyCode];
  
  static bool isPressed(int keyCode) => _lastKeys[keyCode];
  
  static load() {
    for(int i = 0; i < 256; i++) {
       if(_lastKeys[i] || _banKeys[i]) {
         _lastKeys[i]=false;
         _banKeys[i] =true;
       } else if(_keys[i]) {
         _lastKeys[i]= true; 
       }
    }
  }
  
  static end() {
    for(int i = 0; i < 256; i++) {
      if(!_keys[i]) _banKeys[i]=false;
    }
  }
  
}